"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSaveDecorator = createSaveDecorator;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _save = require("./save");

var AsyncLocalStorage =
/*#__PURE__*/
function () {
  function AsyncLocalStorage() {
    (0, _classCallCheck2["default"])(this, AsyncLocalStorage);
  }

  (0, _createClass2["default"])(AsyncLocalStorage, null, [{
    key: "getItem",
    value: function getItem(key) {
      return _regenerator["default"].async(function getItem$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", localStorage.getItem(key));

            case 1:
            case "end":
              return _context.stop();
          }
        }
      });
    }
  }, {
    key: "setItem",
    value: function setItem(key, value) {
      return _regenerator["default"].async(function setItem$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", localStorage.setItem(key, value));

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      });
    }
  }]);
  return AsyncLocalStorage;
}();

var MemoryStorage =
/*#__PURE__*/
function () {
  function MemoryStorage() {
    (0, _classCallCheck2["default"])(this, MemoryStorage);
  }

  (0, _createClass2["default"])(MemoryStorage, null, [{
    key: "getItem",
    value: function getItem(key) {
      return _regenerator["default"].async(function getItem$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt("return", MemoryStorage.db[key]);

            case 1:
            case "end":
              return _context3.stop();
          }
        }
      });
    }
  }, {
    key: "setItem",
    value: function setItem(key, value) {
      return _regenerator["default"].async(function setItem$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              return _context4.abrupt("return", MemoryStorage.db[key] = value);

            case 1:
            case "end":
              return _context4.stop();
          }
        }
      });
    }
  }]);
  return MemoryStorage;
}();

MemoryStorage.db = {};
var Storage = typeof navigator === 'undefined' ? MemoryStorage : AsyncLocalStorage;

function createSaveDecorator(baseOptions) {
  return (0, _save.createDecorator)(Storage, baseOptions);
}

var _default = createSaveDecorator();

exports["default"] = _default;